test_cases:

  - user_agent_string: 'Mozilla/5.0 (X11i; Linux; C) AppleWebKikt/533.3 (KHTML, like Gecko) QtCarBrowser Safari/533.3'
    family: 'QtCarBrowser'
    major: '1'
    minor:
    patch:

  - user_agent_string: 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_7_4) AppleWebKit/537.8+ (KHTML, like Gecko) Version/6.0 Safari/536.25'
    family: 'WebKit Nightly'
    major: '537'
    minor: '8'
    patch:

  - user_agent_string: 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) Version/5.1.1 Safari/534.51.22'
    family: 'WebKit Nightly'
    major: '534'
    minor:
    patch:

  - user_agent_string: 'facebookexternalhit/1.1 (+http://www.facebook.com/externalhit_uatext.php)'
    family: 'FacebookBot'
    major: '1'
    minor: '1'
    patch:

  - user_agent_string: 'Pingdom.com_bot_version_1.4_(http://www.pingdom.com/)'
    family: 'PingdomBot'
    major: '1'
    minor: '4'
    patch:

  - user_agent_string: 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) Version/5.1.1 Safari/534.51.22'
    family: 'WebKit Nightly'
    major: '534'
    minor:
    patch:

  - user_agent_string: 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.1+ (KHTML, like Gecko) Version/5.1.1 Safari/534.51.22'
    family: 'WebKit Nightly'
    major: '537'
    minor: '1'
    patch:

  - user_agent_string: 'Mozilla/5.0 (Linux x86_64) AppleWebKit/534.26+ WebKitGTK+/1.4.1 luakit/f3a2dbe'
    family: 'LuaKit'
    major:
    minor:
    patch:

  - user_agent_string: 'Mozilla/5.0 (X11; Linux x86_64; rv:2.0) Gecko/20110408 conkeror/0.9.3'
    family: 'Conkeror'
    major: '0'
    minor: '9'
    patch: '3'

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1.16) Gecko/20110302 Conkeror/0.9.2 (Debian-0.9.2+git100804-1)'
    family: 'Conkeror'
    major: '0'
    minor: '9'
    patch: '2'


  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; rv:1.9.2.17) Gecko/20110414 Lightning/1.0b3pre Thunderbird/3.1.10'
    family: 'Lightning'
    major: '1'
    minor: '0'
    patch: 'b3pre'

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.2.17) Gecko/20110414 Thunderbird/3.1.10 ThunderBrowse/3.3.5'
    family: 'ThunderBrowse'
    major: '3'
    minor: '3'
    patch: '5'

  - user_agent_string: 'Mozilla/5.0 (Windows; U; en-US) AppleWebKit/531.9 (KHTML, like Gecko) AdobeAIR/2.5.1'
    family: 'AdobeAIR'
    major: '2'
    minor: '5'
    patch: '1'

  - user_agent_string: 'Mozilla/5.0 (compatible; Googlebot/2.1; +http://www.google.com/bot.html)'
    family: 'Googlebot'
    major: '2'
    minor: '1'
    patch:

  - user_agent_string: 'Mozilla/5.0 YottaaMonitor;'
    family: 'YottaaMonitor'
    major:
    minor:
    patch:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/534.3 (KHTML, like Gecko) RockMelt/0.8.34.841 Chrome/6.0.472.63 Safari/534.3'
    family: 'RockMelt'
    major: '0'
    minor: '8'
    patch: '34'

  - user_agent_string: 'Mozilla/5.0 (X11; Linux x86_64; rv:2.0) Gecko/20110417 IceCat/4.0'
    family: 'IceCat'
    major: '4'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux i686; nl-NL) AppleWebKit/534.3 (KHTML, like Gecko) WeTab-Browser Safari/534.3'
    family: 'WeTab'
    major:
    minor:
    patch:

  - user_agent_string: 'Mozilla/4.0 (compatible; Linux 2.6.10) NetFront/3.3 Kindle/1.0 (screen 600x800)'
    family: 'Kindle'
    major: '1'
    minor: '0'
    patch:

  - user_agent_string: 'Opera/9.80 (Android 3.2; Linux; Opera Tablet/ADR-1106291546; U; en) Presto/2.8.149 Version/11.10'
    family: 'Opera Tablet'
    major: '11'
    minor: '10'
    patch:

  - user_agent_string: 'Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/534+ (KHTML, like Gecko) FireWeb/1.0.0.0'
    family: 'FireWeb'
    major: '1'
    minor: '0'
    patch: '0'

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/532.5 (KHTML, like Gecko) Comodo_Dragon/4.1.1.11 Chrome/4.1.249.1042 Safari/532.5'
    family: 'Comodo Dragon'
    major: '4'
    minor: '1'
    patch: '1'

  - user_agent_string: 'Mozilla/5.0 (iPod; U; CPU iPhone OS 4_3_2 like Mac OS X; en-us) AppleWebKit/533.17.9 (KHTML, like Gecko) Version/5.0.2 Mobile/8H7 Safari/6533.18.5'
    family: 'Mobile Safari'
    major: '5'
    minor: '0'
    patch: '2'

  - user_agent_string: 'Mozilla/5.0 (Linux; U; Android 3.0.1; en-us; GT-P7510 Build/HRI83) AppleWebKit/534.13 (KHTML, like Gecko) Version/4.0 Safari/534.13'
    family: 'Android'
    major: '3'
    minor: '0'
    patch: '1'

  - user_agent_string: 'Mozilla/5.0 (hp-tablet; Linux; hpwOS/3.0.0; U; en-US) AppleWebKit/534.6 (KHTML, like Gecko) wOSBrowser/233.58 Safari/534.6 TouchPad/1.0'
    family: 'webOS TouchPad'
    major: '1'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 7.0; Windows Phone OS 7.0; Trident/3.1; IEMobile/7.0; SAMSUNG; SGH-i917)'
    family: 'IE Mobile'
    major: '7'
    minor: '0'
    patch:


  - user_agent_string: 'Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_5_7; en-us) AppleWebKit/530.17 (KHTML, like Gecko) Version/4.0 Safari/530.17 Skyfire/2.0'
    family: 'Skyfire'
    major: '2'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/5.0 (PlayBook; U; RIM Tablet OS 1.0.0; en-US) AppleWebKit/534.8+ (KHTML, like Gecko) Version/0.0.1 Safari/534.8+'
    family: 'Blackberry WebKit'
    major: '1'
    minor: '0'
    patch: '0'

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux i686; en-US) AppleWebKit/534.16 (KHTML, like Gecko) Ubuntu/10.10 Chromium/10.0.648.133 Chrome/10.0.648.133 Safari/534.16'
    family: 'Chromium'
    major: '10'
    minor: '0'
    patch: '648'

  - user_agent_string: 'Mozilla/5.0 (Windows NT 5.1; rv:2.0) Gecko/20110407 Firefox/4.0.3 PaleMoon/4.0.3'
    family: 'Pale Moon (Firefox Variant)'
    major: '4'
    minor: '0'
    patch: '3'

  - user_agent_string: 'Opera/9.80 (Series 60; Opera Mini/6.24455/25.677; U; fr) Presto/2.5.25 Version/10.54'
    family: 'Opera Mini'
    major: '6'
    minor: '24455'
    patch:

  - user_agent_string: 'Mozilla/5.0 (X11; Linux i686 (x86_64); rv:2.0b4) Gecko/20100818 Firefox/4.0b4'
    family: 'Firefox Beta'
    major: '4'
    minor: '0'
    patch: 'b4'

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux x86_64; en-US; rv:1.9.2.12) Gecko/20101027 Ubuntu/10.04 (lucid) Firefox/3.6.12'
    family: 'Firefox'
    major: '3'
    minor: '6'
    patch: '12'

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.9.1.1pre) Gecko/20090717 Ubuntu/9.04 (jaunty) Shiretoko/3.5.1pre'
    family: 'Firefox (Shiretoko)'
    major: '3'
    minor: '5'
    patch: '1pre'

  - user_agent_string: 'Mozilla/5.0 (X11; Linux x86_64; rv:2.0b8pre) Gecko/20101031 Firefox-4.0/4.0b8pre'
    family: 'Firefox Beta'
    major: '4'
    minor: '0'
    patch: 'b8pre'

  - user_agent_string: 'Mozilla/5.0 (X11; U; BSD Four; en-US) AppleWebKit/533.3 (KHTML, like Gecko) rekonq Safari/533.3'
    family: 'Rekonq'
    major:
    minor:
    patch:

  - user_agent_string: 'Mozilla/5.0 (X11; Linux i686) AppleWebKit/534.34 (KHTML, like Gecko) rekonq/1.0 Safari/534.34'
    family: 'Rekonq'
    major: '1'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/5.0 (X11; U; Linux; de-DE) AppleWebKit/527  (KHTML, like Gecko, Safari/419.3) konqueror/4.3.1'
    family: 'Konqueror'
    major: '4'
    minor: '3'
    patch: '1'

  - user_agent_string: 'SomethingWeNeverKnewExisted'
    family: 'Other'
    major:
    minor:
    patch:

  - user_agent_string: 'Midori/0.2 (X11; Linux; U; en-us) WebKit/531.2 '
    family: 'Midori'
    major: '0'
    minor: '2'
    patch:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 6.1; en-US; rv:1.9.3a1) Gecko/20100208 MozillaDeveloperPreview/3.7a1 (.NET CLR 3.5.30729)'
    family: 'MozillaDeveloperPreview'
    major: '3'
    minor: '7'
    patch: 'a1'

  - user_agent_string: 'Opera/9.80 (Windows NT 5.1; U; ru) Presto/2.5.24 Version/10.53'
    family: 'Opera'
    major: '10'
    minor: '53'
    patch:

  - user_agent_string: 'Opera/9.80 (S60; SymbOS; Opera Mobi/275; U; es-ES) Presto/2.4.13 Version/10.00'
    family: 'Opera Mobile'
    major: '10'
    minor: '00'
    patch:

  - user_agent_string: 'Mozilla/5.0 (webOS/1.2; U; en-US) AppleWebKit/525.27.1 (KHTML, like Gecko) Version/1.0 Safari/525.27.1 Desktop/1.0'
    family: 'webOSBrowser'
    major: '1'
    minor: '2'
    patch:

  - user_agent_string: 'Mozilla/5.0 (iPad; U; CPU OS 3_2 like Mac OS X; en-us) AppleWebKit/531.21.10 (KHTML, like Gecko) Version/4.0.4 Mobile/7B367 Safari/531.21.10'
    family: 'Mobile Safari'
    major: '4'
    minor: '0'
    patch: '4'

  - user_agent_string: 'Mozilla/5.0 (SAMSUNG; SAMSUNG-GT-S8500/S8500XXJEE; U; Bada/1.0; nl-nl) AppleWebKit/533.1 (KHTML, like Gecko) Dolfin/2.0 Mobile WVGA SMM-MMS/1.2.0 OPN-B'
    family: 'Dolfin'
    major: '2'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US; BOLT/2.101) AppleWebKit/530  (KHTML, like Gecko) Version/4.0 Safari/530.17'
    family: 'BOLT'
    major: '2'
    minor: '101'
    patch:

  # Safari
  - user_agent_string: 'Mozilla/5.0 (Macintosh; U; PPC Mac OS X; en-us) AppleWebKit/418.8 (KHTML, like Gecko) Safari/419.3'
    family: 'Safari'
    major:
    minor:
    patch:

  - user_agent_string: 'Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_6_5; en-us) AppleWebKit/533.18.1 (KHTML, like Gecko) Version/5.0.2 Safari/533.18.5'
    family: 'Safari'
    major: '5'
    minor: '0'
    patch: '2'

  # BlackBerry devices
  - user_agent_string: 'Mozilla/5.0 (BlackBerry; U; BlackBerry 9800; en-GB) AppleWebKit/534.1+ (KHTML, like Gecko) Version/6.0.0.141 Mobile Safari/534.1+'
    family: 'Blackberry WebKit'
    major: '6'
    minor: '0'
    patch: '0'

  - user_agent_string: 'Mozilla/5.0 (BlackBerry; U; BlackBerry 9800; en-US) AppleWebKit/534.1  (KHTML, like Gecko) Version/6.0.0.91 Mobile Safari/534.1 '
    family: 'Blackberry WebKit'
    major: '6'
    minor: '0'
    patch: '0'

  # Chrome frame
  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; chromeframe; .NET CLR 2.0.50727; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729; Sleipnir 2.8.5)3.0.30729)'
    js_ua: "{'js_user_agent_string': 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/530.1 (KHTML, like Gecko) Chrome/2.0.169.1 Safari/530.1'}"
    family: 'Chrome Frame (Sleipnir 2)'
    major: '2'
    minor: '0'
    patch: '169'

  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.0; Trident/4.0; chromeframe; SLCC1; .NET CLR 2.0.50727; .NET CLR 3.5.30729; .NET CLR 3.0.30729)'
    js_ua: "{'js_user_agent_string': 'Mozilla/5.0 (Windows; U; Windows NT 5.1; en-US) AppleWebKit/530.1 (KHTML, like Gecko) Chrome/2.0.169.1 Safari/530.1'}"
    family: 'Chrome Frame (IE 8)'
    major: '2'
    minor: '0'
    patch: '169'

  # Chrome Frame installed but not enabled
  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; GTB6; chromeframe; .NET CLR 2.0.50727; .NET CLR 1.1.4322; .NET CLR 3.0.04506.648; .NET CLR 3.5.21022; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)'
    js_ua: "{'js_user_agent_string': 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; chromeframe; .NET CLR 2.0.50727; .NET CLR 1.1.4322; .NET CLR 3.0.04506.648; .NET CLR 3.5.21022; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)'}"
    family: 'IE'
    major: '8'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; GTB6; .NET CLR 2.0.50727; .NET CLR 1.1.4322)'
    js_ua: "{'js_user_agent_string': 'Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.1; Trident/4.0; .NET CLR 2.0.50727; .NET CLR 1.1.4322)', 'js_user_agent_family': 'IE Platform Preview', 'js_user_agent_v1': '9', 'js_user_agent_v2': '0', 'js_user_agent_v3': '1'}"
    family: 'IE Platform Preview'
    major: '9'
    minor: '0'
    patch: '1'

  - user_agent_string: 'Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_6_3; en-us; Silk/1.1.0-80) AppleWebKit/533.16 (KHTML, like Gecko) Version/5.0 Safari/533.16 Silk-Accelerated=true'
    family: 'Silk'
    major: '1'
    minor: '1'
    patch: '0-80'

#  - user_agent_string: 'Mozilla/5.0 (compatible; MSIE 9.0; Windows NT 6.1; Trident/5.0; XBLWP7; ZuneWP7)'
#    family: 'IE Mobile'
#    major: '9'
#    minor: '0'
#    patch:

  - user_agent_string: 'Mozilla/5.0 (compatible; MSIE 9.0; Windows Phone OS 7.5; Trident/5.0; IEMobile/9.0; SAMSUNG; SGH-i917)'
    family: 'IE Mobile'
    major: '9'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/5.0 (compatible; MSIE 9.0; Windows Phone OS 7.5; Trident/5.0; IEMobile/9.0; SAMSUNG; SGH-i917)'
    family: 'IE Mobile'
    major: '9'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1; chromeframe/11.0.660.0)'
    family: 'Chrome Frame'
    major: '11'
    minor: '0'
    patch: '660'

  - user_agent_string: 'PyAMF/0.6.1'
    family: 'PyAMF'
    major: '0'
    minor: '6'
    patch: '1'

  - user_agent_string: 'python-requests/0.14 CPython/2.6 Linux/2.6-43-server'
    family: 'Python Requests'
    major: '0'
    minor: '14'
    patch:

  - user_agent_string: 'Mozilla/5.0 (compatible; MSIE 10.0; Windows NT 6.2; ARM; Trident/6.0)'
    family: 'IE'
    major: '10'
    minor: '0'
    patch:

  - user_agent_string: 'Mozilla/5.0 (BB10; Touch) AppleWebKit/537.3+ (KHTML, like Gecko) Version/10.0.9.388 Mobile Safari/537.3+'
    family: 'Blackberry WebKit'
    major: 
    minor: 
    patch: 
